![logo](img/logo.png)

[![Join the chat at https://gitter.im/consensys/truffle](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/consensys/truffle?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

Truffle is a development environment, testing framework and asset pipeline for Ethereum, aiming to make life as an Ethereum developer easier. With Truffle, you get:

* Built-in smart contract compilation, linking, deployment and binary management.
* Automated contract testing with Mocha and Chai.
* Configurable build pipeline with support for custom build processes.
* Scriptable deployment & migrations framework
* Network management for deploying to many public & private networks.
* Interactive console for direct contract communication
* Instant rebuilding of assets during development.
* External script runner that executes scripts within a Truffle environment.
* Support for JavaScript, SASS, ES6 and JSX built-in.

-------------------------------

Subscribe to our mailing list for news, beta releases and new features!

<!-- Begin MailChimp Signup Form -->
<link href="//cdn-images.mailchimp.com/embedcode/slim-10_7.css" rel="stylesheet" type="text/css">
<style type="text/css">
	#mc_embed_signup{background:#FCFCFC; clear:left; font:14px Helvetica,Arial,sans-serif; }
  #mc_embed_signup form{padding-left: 0px; padding-top: 0px;}
  #mc_embed_signup input.email{display: inline-block; vertical-align: top; margin-right: 5px; min-height: 33px; color: black;}
</style>
<div id="mc_embed_signup">
<form action="//readthedocs.us14.list-manage.com/subscribe/post?u=563e4b50100f771d2d17cf7a5&amp;id=b754a8ab50" method="post" id="mc-embedded-subscribe-form" name="mc-embedded-subscribe-form" class="validate" target="_blank" novalidate>
    <div id="mc_embed_signup_scroll">
	<input type="email" value="" name="EMAIL" class="email" id="mce-EMAIL" placeholder="email address" required>
    <!-- real people should not fill this in and expect good things - do not remove this or risk form bot signups-->
    <div style="position: absolute; left: -5000px;" aria-hidden="true"><input type="text" name="b_563e4b50100f771d2d17cf7a5_b754a8ab50" tabindex="-1" value=""></div>
    <div class="clear"><input type="submit" value="Subscribe" name="subscribe" id="mc-embedded-subscribe" class="btn btn-neutral"></div>
    </div>
</form>
</div>

<!--End mc_embed_signup-->

-------------------------------


<script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

  ga('create', 'UA-83874933-1', 'auto');
  ga('send', 'pageview');
</script>
